#include "General\General.h"
// #include "GSM\GSM.h"
// #include "GPS\GPS.h"
// #include "HEATING\Heating.h"
#include "UART\uart.h"
#include "Countdown\Countdown.h"

#include <stdio.h>
#include <string.h>


/**************************/
/*  Program modes         */
/**************************/
uint8_t cAppMode;
#define MODE_STARTUP          0x01    // mode during power on
#define MODE_LOW_BATTERY      0x02    // mode if car battery is too empty
#define MODE_NORMAL           0xFF    // Normal mode (show clock and oil status and wait for the next measure trigger event)


/**************************/
/*  Prototypes            */
/**************************/
// void ExecuteStartUpMode();
// void ExecuteNormalMode();
// void ExecuteLowBatMode();

char SMS_TxBuffer[160];	// One SMS can have up to 160 bytes;
char APP_VERSION[] = "1.0";

void TEST();

int main()
{
  // Initialize AppMode
  cAppMode = MODE_STARTUP;

//   // Initialize peripheries
//   GSM_InitInterface();
//   GPS_InitInterface();
//   Heating_Init();

  // Initialize count down timer
  Countdown_Init();

  // Enable interrupts for communication and countdown timer
  sei();

  while(1)
  {
//     switch (cAppMode)
//     {
//       case MODE_STARTUP:
//         ExecuteStartUpMode();
//         break;
//       case MODE_LOW_BATTERY:
//         ExecuteLowBatMode();
//         break;
//       case MODE_NORMAL:
//       default:
//         ExecuteNormalMode();
//         break;
//     }
  }

  return 0;
}

ISR(BADISR_vect)
{
  // Check, if this should be used...
  // 
  // Damit kannst du einen verselbstndigten Interrupt abfangen. Sonst wird
  // ein Sprung auf den Reset-Vektor ausgefhrt.
}

